/**
 * 
 */
package sim.application;

import sim.exception.SConstructorException;
import sim.exception.SNoImplementationException;
import sim.graphics.SChart;
import sim.graphics.SImageUtil;
import sim.math.SRealFunction;
import sim.util.SLog;

/**
 * L'application <b>SIMFunction</b> reprsente un espace pour utiliser des fonctions.
 * 
 * @author Simon Vzina
 * @since 2017-05-27
 * @version 2020-01-23 (Version labo : Les fonctions discrtes)
 */
public class SIMFunction {

  /**
   * @param args
   */
  public static void main(String[] args) 
  {
    etape_1_1();
    etape_1_4();
    etape_2_3();
    etape_2_5();
    etape_3_4();
    etape_3_5();   
  }
    
  /**
   * Mthode correspondant  l'tape 1.1 du laboratoire : Les fonctions discrtes.
   * 
   * Cette mthode ralise l'affichage de la fonction f(x) = 1 dans un fichier image PNG.
   */
  private static void etape_1_1()
  {
    // Dfinition du domaine de la fonctions.
    double x_min = -1.0;
    double x_max = 8.0;
    
    // Dfinition du nombre d'lments discret de la fonction discrte.
    int nb = 2000;  
    
    // Construction de la foncion f(x) = 1 avec nb lments discret sur le domaine [-1, 8].
    SRealFunction f = SRealFunction.one(nb, x_min, x_max);
    
    // Construction d'un graphique reprsentant la fonction f(x).
    int height = 500;
    double y_min = -1.0;
    double y_max = 2.0;
    String title = "Graphique : f(x) = 1";
    SChart chart = new SChart(f, y_min, y_max, height, title);
    
    // Affichage d'une image correspondant au grahpique de la fonction f(x).
    String file_name = "etape_1_1.png"; 
    
    SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage());
    
    SLog.logWriteLine("Fin de l'excution de l'tape 1.1 .");
  }
  
  /**
   * Mthode correspondant  l'tape 1.4 du laboratoire : Les fonctions discrtes.
   * 
   * Cette mthode ralise l'affichage de la fonction f(x) = x dans un fichier image PNG.
   */
  private static void etape_1_4()
  {
    try{
      
      // Dfinition du domaine de la fonctions.
      double x_min = -1.0;
      double x_max = 8.0;
      
      // Dfinition du nombre d'lments discret de la fonction discrte.
      int nb = 2000;  
      
      // Construction de la foncion f(x) = x avec nb lments discret sur le domaine [-1, 8].
      
      //*******************************************************************************
      //  REMARQUER : C'EST ICI QUE L'ON A CHANG LA FONCTION f(x) = 1 POUR f(x) = x.
      //               
      // La ligne de 1.1 tait : SRealFunction f = SRealFunction.one(nb, x_min, x_max);
      //*******************************************************************************
      SRealFunction f = SRealFunction.x(nb, x_min, x_max);
      
      // Construction d'un graphique reprsentant la fonction f(x).
      int height = 500;
      double y_min = -1.0;
      double y_max = 10.0;
      String title = "Graphique : f(x) = x";
      SChart chart = new SChart(f, y_min, y_max, height, title);
      
      // Affichage d'une image correspondant au grahpique de la fonction f(x).
      String file_name = "etape_1_4.png"; 
      
      SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage());   
      
      SLog.logWriteLine("Fin de l'excution de l'tape 1.4 .");
      
    }catch(SNoImplementationException e){
      SLog.logWriteLine("L'excution de l'tape 1.4 n'a pas t ralise, car une mthode ncessaire au fonctionnement n'a pas t implmente.");
    }
  }
  
  /**
   * Mthode correspondant  l'tape 2.3 du laboratoire : Les fonctions discrtes.
   * 
   * Cette mthode ralise l'affichage de la fonction f(x) = 3x + 1 dans un fichier image PNG.
   */
  private static void etape_2_3()
  {
    try{
      
      // Dfinition du domaine de la fonctions.
      double x_min = -1.0;
      double x_max = 8.0;
      
      // Dfinition du nombre d'lments discret de la fonction discrte.
      int nb = 2000;  
      
      // La fonction qui est  construire.
      SRealFunction f = null;
      
      //****************************************************************************************
      // Effectuez vos oprations mathmatiques ICI afin de dfinir adquatement la fonction f.
      //****************************************************************************************
      
      
      
      // Construction d'un graphique reprsentant la fonction f(x).
      int height = 500;
      double y_min = -10.0;
      double y_max = 40.0;
      String title = "Graphique : f(x) = 3x + 1";
      SChart chart = new SChart(f, y_min, y_max, height, title);
      
      // Affichage d'une image correspondant au grahpique de la fonction f(x).
      String file_name = "etape_2_3.png"; 
      
      SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage());    
      
      SLog.logWriteLine("Fin de l'excution de l'tape 2.3 .");
      
    }catch(SNoImplementationException e){
      SLog.logWriteLine("L'excution de l'tape 2.3 n'a pas t ralise, car une mthode ncessaire au fonctionnement n'a pas t implmente.");
    }catch(SConstructorException e){
      SLog.logWriteLine("L'excution de l'tape 2.3 n'a pas t ralise, car la fonction a afficher est 'null'.");
    }
  }
  
  /**
   * Mthode correspondant  l'tape 2.5 du laboratoire : Les fonctions discrtes.
   * 
   * Cette mthode ralise l'affichage de la fonction f(x) = 4x^2 -5x + 1/(x-2) dans un fichier image PNG.
   */
  private static void etape_2_5()
  {
    try{    
      
      // Dfinition du domaine de la fonctions.
      double  x_min = -2.0;
      double x_max = 5.0;
      
      // Dfinition du nombre d'lments discret de la fonction discrte.
      int nb = 2000;  
      
      // La fonction qui est  construire.
      SRealFunction f = null;
      
      //****************************************************************************************
      // Effectuez vos oprations mathmatiques ICI afin de dfinir adquatement la fonction f.
      //****************************************************************************************
      
      
      
      // Construction d'un graphique reprsentant la fonction f(x).
      int height = 500;
      double y_min = -10.0;
      double y_max = 40.0;
      String title = "Graphique : f(x) = 4x^2 -5x + 1/(x-2)";
      SChart chart = new SChart(f, y_min, y_max, height, title);
      
      // Affichage d'une image correspondant au grahpique de la fonction f(x).
      String file_name = "etape_2_5.png"; 
      
      SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage());    
      
      SLog.logWriteLine("Fin de l'excution de l'tape 2.5 .");
      
    }catch(SNoImplementationException e){
      SLog.logWriteLine("L'excution de l'tape 2.5 n'a pas t ralise, car une mthode ncessaire au fonctionnement n'a pas t implmente.");
    }catch(SConstructorException e){
      SLog.logWriteLine("L'excution de l'tape 2.5 n'a pas t ralise, car la fonction a afficher est 'null'.");
    }
    
  }
  
  /**
   * Mthode correspondant  l'tape 3.4 du laboratoire : Les fonctions discrtes.
   * 
   * Cette mthode ralise l'affichage de la fonction f(x) = 3x^2 + 5x - 6 et la fonction g(x) = f'(x).
   */
  private static void etape_3_4()
  {
    try{
      
      // Dfinition du domaine de la fonctions.
      double  x_min = -3.0;
      double x_max = 3.0;
      
      // Dfinition du nombre d'lments discret de la fonction discrte.
      int nb = 2000;  
      
      // La fonction qui est  construire.
      SRealFunction f = null;
      SRealFunction g = null;
        
      //********************************************************************************************
      // Effectuez vos oprations mathmatiques ICI afin de dfinir adquatement la fonction f et g.
      //********************************************************************************************
            
      
      
      // Construction d'un graphique reprsentant la fonction f(x).
      int height = 500;
      double y_min = -10.0;
      double y_max = 20.0;
      String title = "Graphique : f(x) = 3x^2 + 5x - 6";
      SChart chart = new SChart(f, y_min, y_max, height, title);
      
      // Affichage d'une image correspondant au grahpique de la fonction f(x).
      String file_name = "etape_3_4a.png"; 
      
      SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage());   
      
      // Construction d'un graphique reprsentant la fonction f'(x).
      title = "Graphique : g(x) = f '(x)";
      chart = new SChart(g, y_min, y_max, height, title);
      file_name = "etape_3_4b.png"; 
      
      SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage()); 
      
      SLog.logWriteLine("Fin de l'excution de l'tape 3.4 .");
      
    }catch(SNoImplementationException e){
      SLog.logWriteLine("L'excution de l'tape 3.4 n'a pas t ralise, car une mthode ncessaire au fonctionnement n'a pas t implmente.");
    }catch(SConstructorException e){
      SLog.logWriteLine("L'excution de l'tape 3.4 n'a pas t ralise, car la fonction a afficher est 'null'.");
    }
  }
  
  
  /**
   * Mthode correspondant  l'tape 3.5 du laboratoire : Les fonctions discrtes.
   * 
   * Cette mthode ralise l'affichage de la loi de Planck ainsi que sa drive.
   */
  private static void etape_3_5()
  {
    try{
      
      // Dfinition du domaine de la fonctions.
      double x_min = 0;
      double x_max = 5e-6;
      
      // Dfinition du nombre d'lments discret de la fonction discrte.
      int nb = 4000;  
          
      // La fonction qui est  construire.
      SRealFunction f = null;
      SRealFunction g = null;
      
      //********************************************************************************************
      // Effectuez vos oprations mathmatiques ICI afin de dfinir adquatement la fonction f et g.
      //********************************************************************************************
            
      
      
      // Construction d'un graphique reprsentant la fonction f(x).
      int height = 2000;
      double y_min = 0.0;
      double y_max = 4e12;
      String title = "Graphique : La loi de Planck";
      SChart chart = new SChart(f, y_min, y_max, height, title);
            
      // Affichage d'une image correspondant au grahpique de la fonction f(x).
      String file_name = "etape_3_5a.png"; 
      
      SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage());   
      
      // Construction d'un graphique reprsentant la fonction f'(x).
      title = "Graphique : La drive de la loi de Planck par rapport  la longueur d'onde";
      y_min = -0.5e19;
      y_max = 1e19;
      chart = new SChart(g, y_min, y_max, height, title);
      file_name = "etape_3_5b.png"; 
      
      SImageUtil.writeImagePNG(file_name, chart.buildBufferedImage()); 
      
      SLog.logWriteLine("Fin de l'excution de l'tape 3.5 .");
      
    }catch(SNoImplementationException e){
      SLog.logWriteLine("L'excution de l'tape 3.5 n'a pas t ralise, car une mthode ncessaire au fonctionnement n'a pas t implmente.");
    }catch(SConstructorException e){
      SLog.logWriteLine("L'excution de l'tape 3.5 n'a pas t ralise, car la fonction a afficher est 'null'.");
    }
  }
    
}
