/**
 * 
 */
package sim.exception;

/**
 * La classe <b>SNoImplementationException</b> reprsente une exception lanc lorsqu'une mthode n'est pas implmente.
 * 
 * @author Simon Vzina
 * @since 2015-01-25
 * @version 2018-01-17
 */
public class SNoImplementationException extends RuntimeException {

  private static final String DEFAULT_MESSAGE = "La mthode n'a pas t implmente.";
  
  /**
   * La variable <b>serialVersionUID<b> correspond  un code d'identification de l'exception.
   */
	private static final long serialVersionUID = -9055388404780943775L;

	/**
   * Constructeur de l'exception avec un message d'erreur par dfaut.
   */
  public SNoImplementationException()
  {
    super(DEFAULT_MESSAGE);
  }
	
	/**
   * Constructeur de l'exception avec message d'erreur.
   * 
   * @param message - Le message de l'erreur.
   */
	public SNoImplementationException(String message)
	{
		super(message);
	}

	/**
   * Constructeur de l'exception avec message d'erreur et cause de l'exception.
   * 
   * @param message - Le message de l'erreur.
   * @param cause - La cause de l'erreur.
   */
	public SNoImplementationException(String message, Throwable cause)
	{
		super(message, cause);
	}
	
}//fin de la classe SNoImplementationException
