/**
 * 
 */
package sim.math;

import sim.exception.SNoImplementationException;

/**
 * La classe <b>SDiscreteFunction</b> est une classe utilitaire permettant d'effectuer des oprations mathmatiques sur des fonctions discrtes.
 * 
 * @author Simon Vzina
 * @since 2018-03-29
 * @version 2020-01-31 (Version Labo v 1.101 : Les fonctions discrtes)
 */
public class SDiscreteFunction {

  /**
   * Mthode pour obtenir l'intervalle dx entre deux lments conscutif de la fonction discrte f(x).
   * 
   * @param fx Le tableau des valeurs de la fonction f(x).
   * @param x_min La valeur minimale du domaine.
   * @param x_max La valeur maximale du domaine.
   * @return La distance dx entre deux lments discret du domaine de la fonction f(x).
   * @throws IllegalArgumentException Si le tableau de valeurs est de taille infrieure  2.
   */
  public static double dx(double[] fx, double x_min, double x_max) throws IllegalArgumentException
  {
    if(fx.length < 2)
      throw new IllegalArgumentException("Erreur SDiscreteFunction 001 : La fonction fx possde moins de 2 lments ce qui ne permet pas de dfinir un paramtre dx.");
    
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
  }
  
  /**
   * Mthode pour obtenir l'indice i associ  une coordonne x d'une fonction discrte f(x).
   * Lorsque x = x_min, i = 0. Lorsque x = x_max, i = length-1.
   * 
   * @param x La valeur x  convertir.
   * @param fx Le tableau reprsentant la fonction.
   * @param x_min Le dbut du domaine.
   * @param x_max La fin du domaine.
   * @return L'indice dans le tableau de la fonction.
   */
  public static int xToIndex(double x, double[] fx, double x_min, double x_max) 
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
     
  }
  
  /**
   * Mthode pour obtenir une coordonne x associ  un indice i d'une fonction discrte f(x).
   * Lorsque i = 0, x = x_min. Lorsque i = length-1, x = x_max.
   * 
   * @param i L'indice dans le tableau de la fonction  convertir.
   * @param fx Le tableau reprsentant la fonction.
   * @param x_min Le dbut du domaine.
   * @param x_max La fin du domaine.
   * @return La coordonne x.
   * @throws IndexOutOfBoundsException Si l'indice i n'est pas accessible dans le tableau.
   */
  public static double indexToX(int i, double[] fx, double x_min, double x_max) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode pour valuer une fonction discrte f(x)  une coordonne x.
   * 
   * @param x La coordonne x.
   * @param fx Le tableau reprsentant la fonction.
   * @param x_min Le dbut du domaine.
   * @param x_max La fin du domaine.
   * @return La valeur de la fonction f(x) en coordonne x.
   * @throws IndexOutOfBoundsException
   */
  public static double f(double x, double[] fx, double x_min, double x_max) throws IndexOutOfBoundsException
  {
    return fx[xToIndex(x, fx, x_min, x_max)];
  }
  
  /**
   * Mthode pour valuer la drive f'(x) d'une fonction discrte f(x)  une coordonne x.
   * 
   * @param x La coordonne x.
   * @param fx Le tableau reprsentant la fonction.
   * @param x_min Le dbut du domaine.
   * @param x_max La fin du domaine.
   * @return La drive de la fonction f(x) en coordonne x.
   * @throws IndexOutOfBoundsException
   */
  public static double dfdx(double x, double[] fx, double x_min, double x_max) throws IndexOutOfBoundsException
  {
    return dfdx(xToIndex(x, fx, x_min, x_max), fx, dx(fx, x_min, x_max));
  }
  
  /**
   * Mthode pour valuer la drive f'(x) d'une fonction discrte f(x)  un indice i.
   * 
   * @param i L'indice dans le tableau.
   * @param fx Le tableau reprsentant la fonction.
   * @param dx La distance entre deux lments conscutifs du tableau.
   * @return La drive de la fonction en indice i.
   * @throws IndexOutOfBoundsException Si l'indice i n'est pas accessible.
   */
  public static double dfdx(int i, double[] fx, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
   
  }
  
  /**
   * Mthode qui value la drive f'(x) d'une fonction discrte f(x)  un indice i selon la mthode de la <u>drive  gauche</u>.
   * 
   * @param i L'indice dans le tableau.
   * @param fx Le tableau reprsentant la fonction.
   * @param dx La distance entre deux lments conscutifs du tableau.
   * @return La drive de la fonction en indice i.
   * @throws IndexOutOfBoundsException Si l'indice i n'est pas accessible.
   */
  public static double leftDerivate(int i, double[] fx, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode qui value la drive f'(x) d'une fonction discrte f(x)  un indice i selon la mthode de la <u>drive  droite</u>.
   * 
   * @param i L'indice dans le tableau.
   * @param fx Le tableau reprsentant la fonction.
   * @param dx La distance entre deux lments conscutifs du tableau.
   * @return La drive de la fonction en indice i.
   * @throws IndexOutOfBoundsException Si l'indice i n'est pas accessible.
   */
  public static double rightDerivate(int i, double[] fx, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode qui value la drive f'(x) d'une fonction discrte f(x)  un indice i selon la mthode de la <u>drive au centre</u>.
   * 
   * @param i L'indice dans le tableau.
   * @param fx Le tableau reprsentant la fonction.
   * @param dx La distance entre deux lments conscutifs du tableau.
   * @return La drive de la fonction en indice i.
   * @throws IndexOutOfBoundsException Si l'indice i n'est pas accessible.
   */
  public static  double middleDerivate(int i, double[] fx, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode qui value la drive f'(x) d'une fonction discrte f(x)  un indice i selon la mthode de la <u>drive  cinq points</u>.
   * 
   * Rfrence : https://en.wikipedia.org/wiki/Five-point_stencil
   * 
   * @param i L'indice dans le tableau.
   * @param fx Le tableau reprsentant la fonction.
   * @param dx La distance entre deux lments conscutifs du tableau.
   * @return La drive de la fonction en indice i.
   * @throws IndexOutOfBoundsException Si l'indice i n'est pas accessible.
   */
  public static double fivePointsDerivate(int i, double[] fx, double dx) throws IndexOutOfBoundsException
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode qui value la drive discrte f'(x) d'une fonction f(x).
   * 
   * @param fx Le tableau reprsentant la fonction.
   * @param x_min Le dbut du domaine.
   * @param x_max La fin du domaine.
   * @return Un tableau correspondant  la drive de chaque lment du tableau de la fonction prcdente.
   */
  public static double[] derivate(double[] fx, double x_min, double x_max)
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode pour valuer la primitive F(x) d'une fonction discrte f(x)  une coordonne x.
   * 
   * @param x
   * @param fx
   * @param C La constante d'intgration de la fonction F(x) qui est value  la coordonne x_min.
   * @param x_min
   * @param x_max
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double Fx(double x, double[] fx, double C, double x_min, double x_max) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode pour valuer la primitive F(x) d'une fonction discrte f(x) entre un indice i et j.
   * 
   * @param i
   * @param j
   * @param fx
   * @param C
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double Fx(int i, int j, double[] fx, double C, double dx) throws IndexOutOfBoundsException, IllegalArgumentException
  {
    if(i > j)
      throw new IllegalArgumentException("Erreur SDiscreteFunction 005 : L'indice i = " + i + " est plus grand que l'argument j = " + j + ".");
   
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
   
  }
    
  /**
   * ...
   * 
   * @param i
   * @param j
   * @param fx
   * @param C
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double leftIntegrate(int i, int j, double[] fx, double C, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * ...
   * 
   * @param i
   * @param j
   * @param fx
   * @param C
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double rightIntegrate(int i, int j, double[] fx, double C, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * ...
   * 
   * @param i
   * @param j
   * @param fx
   * @param C
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double middleIntegrate(int i, int j, double[] fx, double C, double dx) throws IndexOutOfBoundsException
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode pour valuer l'intgrale F(x) de la fonction f'(x)  l'indice i.
   *  
   * @param i
   * @param f
   * @param F Les valeurs de la fonction F(x) dj values qui serviront de conditions initiales (constante C) dans l'valuation de la fonction pour d'autre indice i.
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double Fx(int i, double[] f, double[] F, double dx) throws IndexOutOfBoundsException 
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * ...
   * 
   * @param i
   * @param f
   * @param F
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double leftRuleIntegrate(int i, double[] f, double[] F, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
   
  }
  
  /**
   * 
   * @param i
   * @param f
   * @param F
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double rightRuleIntegrate(int i, double[] f, double[] F, double dx) throws IndexOutOfBoundsException
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * 
   * @param i
   * @param f
   * @param F
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double middleRuleIntegrate(int i, double[] f, double[] F, double dx) throws IndexOutOfBoundsException
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode qui effectue le calcul de l'aire sous la courbe d'une fonction dans l'intervalle [i-2, i]
   * selon la mthode de Simpson 1/3.
   * 
   * Rfrence : https://fr.wikipedia.org/wiki/M%C3%A9thode_de_Simpson
   * 
   * @param i
   * @param f
   * @param F
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double simpsonRuleIntegrate(int i, double[] f, double[] F, double dx) throws IndexOutOfBoundsException
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
   
  }
  
  /**
   * Mthode qui effectue le calcul de l'aire sous la courbe d'une fonction dans l'intervalle [i-3, i]
   * selon la mthode de Simpson 3/8.
   * 
   * Rfrence : http://mathworld.wolfram.com/Simpsons38Rule.html
   * 
   * @param i
   * @param f
   * @param F
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double simpsonAdvRuleIntegrate(int i, double[] f, double[] F, double dx) throws IndexOutOfBoundsException
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode qui effectue le calcul de l'aire sous la courbe d'une fonction dans l'intervalle [i-4, i]
   * selon la mthode de Boole.
   * 
   * Rfrence : https://en.wikipedia.org/wiki/Boole%27s_rule
   * 
   * @param i
   * @param f
   * @param F
   * @param dx
   * @return
   * @throws IndexOutOfBoundsException
   */
  public static double booleRuleIntegrate(int i, double[] f, double[] F, double dx) throws IndexOutOfBoundsException
  {
   
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
  /**
   * Mthode pour valuer la prmitive F(x) d'une fonction discrte f(x).
   * 
   * @param f
   * @param C
   * @param x_min
   * @param x_max
   * @return
   */
  public static double[] integrate(double[] f, double C, double x_min, double x_max)
  {
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
    
  }
  
}
